--[[**********************************
*
*	Multi Theft Auto - Admin Panel
*
*	admin_ACL.lua
*
*	Original File by lil_Toady
*
**************************************]]

ACLGroups = {}

function aSetupACL ()
	local node = xmlLoadFile ( "conf\\ACL.xml" )
	if ( node ) then
		local subnode = xmlFindSubNode ( node, "groups", 0 )
		if ( subnode ) then
			local groups = 0
			while ( xmlFindSubNode ( subnode, "group", groups ) ~= false ) do
				local group = xmlFindSubNode ( subnode, "group", groups )
				local id = tonumber ( xmlNodeGetAttribute ( group, "id" ) )
				local name = xmlNodeGetAttribute ( group, "name" )
				local tabs = xmlNodeGetAttribute ( group, "tabs" )
				if ( ( id ) and ( name ) ) then
					ACLGroups[id] = {}
					ACLGroups[id]["name"] = name
					ACLGroups[id]["tabs"] = tabs
					ACLGroups[id]["access"] = {}
				end
				groups = groups + 1
			end
		end
		subnode = xmlFindSubNode ( node, "access", 0 )
		if ( subnode ) then
			local commands = 0
			while ( xmlFindSubNode ( subnode, "command", commands ) ~= false ) do
				local command = xmlFindSubNode ( subnode, "command", commands )
				local name = xmlNodeGetAttribute ( command, "name" )
				local groups = xmlNodeGetAttribute ( command, "groups" )
				if ( ( name ) and ( groups ) ) then
					local access = split ( groups, 44 )
					for id, group in ipairs ( access ) do
						group = tonumber ( group )
						ACLGroups[group]["access"][name] = true
					end
				end
				commands = commands + 1
			end
		end
	end

end

function guiElementACL ( element, right )
	return element
end