/*
 * CodePress regular expressions for Lua syntax highlighting
 * http://d.hatena.ne.jp/winebarrel/20071216/p2
 */
 
// Lua
Language.syntax = [ 
	{ input : /\"(.*?)(\"|<br>|<\/P>)/g, output : '<s>"$1$2</s>' }, // strings double quote
	{ input : /\'(.*?)(\'|<br>|<\/P>)/g, output : '<s>\'$1$2</s>' }, // strings single quote
	{ input : /(function\s+)([\w\.]*)/g, output : '$1<em>$2</em>' }, // functions
	{ input : /\b(and|break|do|else|elseif|end|false|for|function|if|in|local|nil|not|or|repeat|return|then|true|until|while)\b/g, output : '<b>$1</b>' }, // reserved words
	{ input : /\b(_G|_VERSION|getElementAlpha|setVehicleModel|isPlayerBetaTester|isElement|setVehicleLightState|removeElementData|getMarkerSize|getVehicleLightState|createColTube|getResourceName|setPlayerStat|setBlipColor|isVehicleFrozen|setElementHealth|createExplosion|textDisplayRemoveText|tonumber|xmlCopyFile|getPlayerStat|getBlipColor|isElementAttached|getElementHealth|isPlayerMapForced|givePlayerMoney|getPlayerBlurLevel|getAccount|getBansXML|getElementChildrenCount|getTeamFriendlyFire|setGameSpeed|getResourceLoadTime|executeSQLInsert|getSlotFromWeapon|setPlayerBlurLevel|setVehicleRespawnPosition|isPlayerQA|fileClose|setVehicleFuelTankExplodable|getVehicleMaxPassengers|getMarkerTarget|attachElementToElement|fileIsEOF|setMarkerSize|getGameSpeed|logOut|logIn|setPlayerNametagColor|getVehicleUpgrades|setPlayerMuted|showPlayerHudComponent|getPlayerWantedLevel|getVehicleOverrideLights|call|setMarkerIcon|setSkyGradient|setPlayerMoney|setControlState|outputServerLog|setPlayerWeaponSlot|textItemSetPosition|getElementPosition|setVehicleOverrideLights|getPlayerArmor|aclGroupRemoveObject|xmlNodeSetAttribute|setPlayerArmor|getControlState|loadlib|getElementsByType|collectgarbage|getWaveHeight|getPlayerOccupiedVehicleSeat|callRemote|isPlayerDead|isElementVisibleTo|resetSkyGradient|getVehicleDoorState|getPlayerTeam|setPlayerGravity|getDistanceBetweenPoints2D|setVehicleDoorState|get|getPlayerGravity|getVehicleNameFromID|getServerPort|setElementID|resetMapInfo|hasObjectPermissionTo|getClientAccount|setPlayerWantedLevel|createVehicle|aclGroupListObjects|aclGroupAddObject|clearElementVisibleTo|toggleAllControls|kickPlayer|getElementID|aclGroupListACL|aclGroupAddACL|getElementChild|aclGroupGetName|getRealTime|aclGroupList|getVehicleController|xmlUnloadFile|xmlFindSubNode|setVehicleIdleRespawnDelay|aclGetGroup|gcinfo|copyAccountData|aclDestroyGroup|createBlip|getVehicleLandingGearDown|setWeaponAmmo|randInt|aclCreate|getVehiclesOfType|giveWeaponAmmo|print|getResourceLoadFailureReason|getElementVelocity|spawnPlayer|aclSetRight|aclGetRight|getWeaponIDFromName|aclList|setBlipIcon|getAllElementData|aclDestroy|aclSave|aclReload|xmlSaveFile|setElementVelocity|removeResourceDefaultSetting|setVehicleFrozen|outputConsole|setPlayerNametagShowing|setResourceDefaultSetting|setVehicleSirensOn|addResourceMap|addEvent|removeResourceFile|getPlayerFightingStyle|addResourceConfig|copyResource|getWeather|aclCreateGroup|resetVehicleExplosionTime|setRadarAreaSize|addEventHandler|getPlayerMoney|startResource|setServerPassword|spawnVehicle|blowVehicle|getResourceExportedFunctions|setRadarAreaFlashing|banPlayer|getVehicleSirensOn|getResourceDynamicElementRoot|unbindKey|getResourceRootElement|toggleVehicleRespawn|getResourceState|setVehicleLandingGearDown|aclRemoveRight|getResourceConfig|getPlayerAmmoInClip|xpcall|stopObject|getResourceInfo|restartResource|isRadarAreaFlashing|setPlayerFightingStyle|getResourceLastStartTime|createElement|getResources|getResourceFromName|getVehicleUpgradeSlotName|require|showCursor|addCommandHandler|getTypeIndexFromClothes|unbanSerial|next|banSerial|setTeamFriendlyFire|getVehicleTowedByVehicle|unbanIP|getVehicleCompatibleUpgrades|getVehicleID|rawequal|banIP|fileSetPos|getResourceMapRootElement|newproxy|setAccountData|setAccountPassword|createRadarArea|takeWeaponAmmo|fixVehicle|addAccount|getPlayerPing|getAccountData|getPlayerTotalAmmo|isGuestAccount|getAccountClient|isKeyBound|getAccountName|getElementType|getObjectRotation|setElementDimension|executeSQLQuery|takeAllWeapons|setWeather|triggerEvent|executeSQLSelect|select|fromJSON|getPlayerSkin|detachElementFromElement|getPlayersInTeam|outputChatBox|getElementDimension|setfenv|getPickupAmount|isInsideRadarArea|setTeamName|getElementChildren|setRuleValue|getRuleValue|setMapName|setGameType|getMapName|killPlayer|getGameType|setVehicleDamageProof|textItemGetPriority|textItemSetPriority|textItemGetColor|getMaxPlayers|textItemSetColor|getElementByID|getElementsWithinColShape|xmlLoadFile|getTickCount|setCameraRotation|getPlayerFromNick|fileGetPos|assert|textItemSetScale|setPlayerChoking|textItemGetText|getDistanceBetweenPoints3D|textItemSetText|setElementVisibleTo|textDisplayAddObserver|textDisplayAddText|load|getBodyPartName|getZoneName|fileCreate|getPlayerNametagText|cloneElement|forcePlayerMap|textDestroyDisplay|getObjectModel|setPlayerRotation|setCameraPosition|isVehicleLocked|getVehicleOccupant|textCreateDisplay|isPlayerChoking|fileFlush|setPlayerNametagText|resetVehicleIdleTime|getVehicleTurretPosition|fileWrite|getColorFromString|getPlayerRotation|removeAccount|textItemGetScale|fileOpen|textCreateTextItem|loadstring|isControlEnabled|setObjectModel|getTeamName|isPlayerInVehicle|xmlCreateFile|xmlNodeGetAttribute|createObject|xmlNodeSetValue|xmlNodeGetValue|createColSphere|setMarkerColor|getRootElement|respawnVehicle|getTimers|countPlayersInTeam|takeWeapon|getFunctionsBoundToKey|setTimer|setVehicleGunsEnabled|getMarkerColor|getElementData|split|textItemGetPosition|fileRead|set|setWaveHeight|setVehicleWheelStates|getElementByIndex|getDeadPlayers|setWeatherBlended|executeSQLUpdate|setTime|setElementData|cancelEvent|givePlayerJetPack|setElementPosition|getAlivePlayers|getPlayerOccupiedVehicle|textDestroyTextItem|toJSON|getServerPassword|getServerHttpPort|getCameraTarget|getServerName|aclListRights|executeSQLCreateTable|setCameraTarget|createTeam|isPlayerInWater|destroyElement|executeSQLDelete|getTime|executeCommandHandler|removeCommandHandler|type|isCursorShowing|aclGetName|getPickupWeapon|getClientName|setVehicleDirtLevel|setVehicleEngineState|isPlayerNametagShowing|setClientName|getPlayerContactElement|triggerClientEvent|saveMapData|createColCuboid|createColCircle|loadfile|setTeamColor|setPlayerTeam|executeSQLDropTable|getTeamColor|xmlDestroyNode|getGravity|getVehiclePanelState|aclGroupRemoveACL|toggleControl|moveObject|getVehiclePlateText|getClothesTypeName|getPickupAmmo|killTimer|createBlipAttachedTo|bindKey|setVehicleRotation|setGravity|playSoundFrontEnd|setPickupType|getKeyBoundToFunction|attachTrailerToVehicle|removeRuleValue|getBlipSize|getWeaponNameFromID|getMarkerType|doesPlayerHaveJetPack|getVehiclePaintjob|getVehicleRotation|setRadarAreaColor|getRadarAreaColor|getRadarAreaSize|randFloat|getThisResource|setObjectRotation|getElementParent|addVehicleUpgrade|setCameraMode|setBlipSize|aclGet|gettok|getVehicleName|giveWeapon|getVehicleTowingVehicle|getBlipIcon|tostring|getClientIP|xmlCreateSubNode|getElementZoneName|getCameraMode|textDisplayRemoveObserver|getVehicleWheelStates|getPlayerNametagColor|getPlayerTarget|getVehicleIDFromName|setMarkerTarget|loadMapData|isPlayerScoreboardForced|getElementColShape|setMarkerType|getMarkerIcon|createColRectangle|setElementParent|createMarker|setCameraLookAt|setElementAlpha|getPickupType|getMarkerCount|takePlayerMoney|setVehiclePaintjob|detachTrailerFromVehicle|addPlayerClothes|stopResource|unpack|setVehicleLocked|createResource|createPickup|getPlayerWeaponSlot|outputDebugString|setVehiclePanelState|setmetatable|getClothesByTypeIndex|getPlayerWeapon|ipairs|getAttachedElements|setVehicleTurnVelocity|removeVehicleUpgrade|wasEventCancelled|setVehicleDoorsUndamageable|pcall|setVehicleColor|pairs|getmetatable|getfenv|isVehicleFuelTankExplodable|removeEventHandler|isElementWithinColShape|getVehicleTurnVelocity|getElementAttachedTo|rawset|setElementInterior|isPlayerDucked|fadeCamera|setPlayerSkin|removePlayerFromVehicle|dofile|getTeamFromName|setPlayerAmmo|isVehicleOnGround|isPlayerMuted|removePlayerClothes|getPlayerClothes|getElementInterior|getVehicleUpgradeOnSlot|removePlayerJetPack|getPlayerUserName|warpPlayerIntoVehicle|rawget|isPlayerDev|setVehicleRespawnDelay|getVehicleColor|getPlayerSerial|isPlayerOnGround|getRandomPlayer|error|getPlayerCount)\b/g, output : '<u>$1</u>' }, // special words
	{ input : /([^:]|^)--(.*?)(<br|<\/P)/g, output : '$1<i>--$2</i>$3' }, // comments
	{ input : /\[(=*)\[(.*?)\](=*)\]/g, output : '<i>[$1[$2]$3]</i>' } // comments
]

Language.snippets = [
	{ input : 'fun', output : 'function $0()\n\t\nend' },
	{ input : 'func', output : 'function $0()\n\t\nend' }
]

Language.complete = [
	{ input : '\'',output : '\'$0\'' },
	{ input : '"', output : '"$0"' },
	{ input : '(', output : '\($0\)' },
	{ input : '[', output : '\[$0\]' },
	{ input : '{', output : '{\n\t$0\n}' }		
]

Language.shortcuts = []
