RankingBoard = {}
RankingBoard.__index = RankingBoard

RankingBoard.instances = {}

function RankingBoard.create(id)
	RankingBoard.instances[id] = setmetatable({ id = id, direction = 'down', labels = {} }, RankingBoard)
end

function RankingBoard.call(id, fn, ...)
	RankingBoard[fn](RankingBoard.instances[id], ...)
end

function RankingBoard:setDirection(direction)
	self.direction = direction
end

function RankingBoard:add(player, time)
	position = #self.labels/2 + 1
	if self.direction == 'up' then
		position = #g_Players + 1 - position
	end
	local posLabel = guiCreateLabel(30, 180 + (position-1)*20, 20, 20, tostring(position) .. ')', false)
	guiLabelSetHorizontalAlign(posLabel, 'right')
	if time then
		if not self.firsttime then
			self.firsttime = time
			time = ': ' .. msToTimeStr(time)
		else
			time = ': +' .. msToTimeStr(time - self.firsttime)
		end
	else
		time = ''
	end
	local playerLabel = guiCreateLabel(60, 180 + (position-1)*20, 200, 20, getPlayerName(player) .. time, false)
	table.insert(self.labels, posLabel)
	table.insert(self.labels, playerLabel)
end

function RankingBoard:clear()
	table.each(self.labels, destroyElement)
	self.labels = {}
end

function RankingBoard:destroy()
	self:clear()
	RankingBoard.instances[self.id] = nil
end
