--[[**********************************
*
*	Multi Theft Auto - Admin Panel
*
*	admin_ACL.lua
*
*	Original File by lil_Toady
*
**************************************]]

ACLCommands = {}

function aSetupACL ()
	local node = xmlLoadFile ( "conf\\ACL.xml" )
	if ( node ) then
		--Get ACLs
		local acls = 0
		while ( xmlFindSubNode ( node, "acl", acls ) ~= false ) do
			local aclNode = xmlFindSubNode ( node, "acl", acls )
			local aclName = xmlNodeGetAttribute ( aclNode, "name" )
			if ( aclName ) then
				local acl = aclGet ( aclName )
				if ( not acl ) then acl = aclCreate ( aclName ) end
				local group = aclGetGroup ( aclName )
				if ( not group ) then group = aclCreateGroup ( aclName ) end
				aclGroupAddACL ( group, acl )
				-- Get Rights
				local rights = 0
				while ( xmlFindSubNode ( aclNode, "right", rights ) ~= false ) do
					local rightNode = xmlFindSubNode ( aclNode, "right", rights )
					local rightName = xmlNodeGetAttribute ( rightNode, "name" )
					local rightAccess = xmlNodeGetAttribute ( rightNode, "access" )
					if ( ( rightName ) and ( rightAccess ) ) then
						if ( rightAccess == "true" ) then rightAccess = true
						else rightAccess = false end
						aclSetRight ( acl, rightName, rightAccess )
						if ( string.find ( rightName, "command." ) ) then
							local command = string.gsub ( rightName, "command.", "" )
							table.insert ( ACLCommands, command )
						end
					end
					rights = rights + 1
				end
			end
			acls = acls + 1
		end
	end
end