--[[**********************************
*
*	Multi Theft Auto - Admin Panel
*
*	admin_commands.lua
*
*	Original File by lil_Toady
*
**************************************]]

_commands = {}

function getPlayerWildcard ( string )
	local player = getPlayerFromNick ( string )
	if ( player ) then return player end
	for id, player in ipairs ( getElementsByType ( "player" ) ) do
		if ( string.find ( getClientName ( player ), string ) ) then
			return player
		end
	end
	return false
end

-- Yet to be finished
function aSetupCommands()
	local node = xmlLoadFile ( "conf\\commands.xml" )
	if ( node ) then
		for id, type in ipairs ( _types ) do
			local subnode = xmlFindSubNode ( node, type, 0 )
			if ( subnode ) then
				local commands = 0
				while ( xmlFindSubNode ( subnode, "command", commands ) ~= false ) do
					local command = xmlFindSubNode ( subnode, "command", commands )
					local handler = xmlNodeGetAttribute ( command, "handler" )
					local call = xmlNodeGetAttribute ( command, "call" )
					_commands[handler] = {}
					_commands[handler].type = type
					_commands[handler].action = call
					--addCommandHandler ( handler, aCommand )
					commands = commands + 1
				end
			end
		end
	end

end

function aCommand ( admin, command, ... )
	local call = _commands[command]
	if ( call ) then
		if ( hasObjectPermissionTo ( admin, "command."..call.action ) ) then
			if ( call.type == "player" ) then
				local target = arg[1]
				if ( target ) then
					local target = getPlayerWildcard ( target )
					if ( not target ) then
						outputChatBox ( "Error - Player not found", admin, 255, 0, 0 )
						return
					end
				else
					target = admin
				end
				triggerEvent ( "aPlayer", admin, target, call.action, arg[2], arg[3] )
			end
		else
			outputChatBox ( "Error - Player not found", admin, 255, 100, 100 )
		end
	end
end